<template>
  <div class="container m-auto flex register-module">
    <div class="xl:w-[1200px] flex-none m-auto rounded-2xl bg-background5 overflow-hidden w-full login-container">
      <div class="h-[64px] bg-background5 flex items-center justify-between py-0 pl-[40px] pr-[16px] title-wrapper">
        <h2 class="text-2xl font-semibold text-[var(--primary)] title">
          {{ $t("joinnow") }}
        </h2>
        <close-button />
      </div>
      <div class="w-full h-[2px] bg-border"></div>
      <div class="flex justify-between" :class="{'form-only': loginRegister.IsHidden}">
        <div class="xl:w-[400px] bg-background5 rounded-l-2xl overflow-hidden login-register-form" :class="{'h-[654px]': !loginRegister.IsHidden}">
          <el-form
            label-position="left"
            class="register-bg rounded pt-6 peru-register-form"
            :class="{'pb-6': loginRegister.IsHidden}"
            :rules="formRules"
            :model="formModel"
            ref="formRef"
          >
            <div class="register-form" :class="{'overflow-y-scroll h-[480px]': !loginRegister.IsHidden}">
              <el-form-item :class="{required : rules.Username.required}" :label="$t('username')" prop="Username">
                <el-input v-model="formModel.Username" />
              </el-form-item>
              <el-form-item :class="{required : rules.Password.required}" :label="$t('password')" prop="Password">
                <el-input type="password" v-model="formModel.Password"  />
              </el-form-item>
              <el-form-item :class="{required : rules.ConfirmPassword.required}" :label="$t('confirm_password')" prop="ConfirmPassword">
                <el-input type="password" v-model="formModel.ConfirmPassword" />
              </el-form-item>
              <el-form-item :class="{required : rules.Currency.required}" :label="$t('currency')" prop="Currency">
                <el-select class="currency" v-model="formModel.Currency" style="width:100%" :placeholder="$t('select_currency')" :disabled="currencies.length <= 0">
                  <template #prefix v-if="formModel.Currency !== ''">
                    <i class="el-icon el-input__icon tick">
                      <svg-icon
                        svg-name="circle-check"
                        class-name="el-form-item.is-success i.el-input__validateIcon object-contain"
                      />
                    </i>
                  </template>
                  <el-option
                    v-for="currency in currencies"
                    :key="currency.Currency"
                    :label="currency.Currency"
                    :value="currency.Currency"
                  />
                </el-select>
              </el-form-item>
              <template v-for="property in availableProperties" :key="property.PropertyName">
              <theme-common-otp-field
                v-if="property.PropertyName === 'Phone'"
                v-model="formModel"
                :label="property.PropertyNameForDisplay"
                :phone-property="property.PropertyName"
                :is-required="rules[property.PropertyName].required"
                :loading="isGettingOtpCode"
                :next-request-in-seconds="nextRequestOtpInSeconds"
                @get-code="onGetVerificationCode"
              >
                <template #phone>
                  <el-form-item 
                    :label="property.PropertyNameForDisplay" :prop="property.PropertyName"
                    :class="{ required: rules[property.PropertyName].required}"
                  >
                    <el-input 
                      v-model="formModel[property.PropertyName]"
                      :formatter="(value: string) => value" 
                      :parser="(value: string) => value.replace(/\D+/g, '')"
                    >
                      <template #suffix>
                        <el-tooltip class="box-item" effect="dark"
                          :content="$t('valid_mobile_number_is_required_for_deposit_and_withdrawal_verification_purposes')"
                          placement="bottom">
                          <el-icon class="el-input__icon" color="var(--primary)">
                            <info-filled />
                          </el-icon>
                        </el-tooltip>
                      </template>
                    </el-input>
                  </el-form-item>
                </template>  
              </theme-common-otp-field>
              <el-form-item 
                v-else
                :label="property.PropertyNameForDisplay" :prop="property.PropertyName"
                :class="{ required: rules[property.PropertyName].required}">
                <el-select v-if="property.PropertyName === 'Bank'" v-model="formModel.Bank" style="width:100%"
                  :placeholder="$t('select_bank')" :disabled="bankOptions.length <= 0">
                  <el-option v-if="bankOptions.length <= 0" label="--" value="0" />
                  <el-option v-else v-for="bank in bankOptions" :key="bank.Id" :label="bank.BankName" :value="String(bank.Id)"/>
                </el-select>
                <el-radio-group v-else-if="property.PropertyName === 'Gender'" v-model="formModel.Gender">
                  <el-radio label="male">{{ $t('male') }}</el-radio>
                  <el-radio label="female">{{ $t('female') }}</el-radio>
                </el-radio-group>
                <el-date-picker v-else-if="property.PropertyName === 'DateOfBirth'" v-model="formModel.DateOfBirth" type="date"
                  value-format="YYYY-MM-DD" />
                <template v-else-if="property.PropertyName === 'Mobile'">
                  <el-input 
                  v-model="formModel[property.PropertyName]" 
                  :formatter="(value: string) => value" 
                  :parser="(value: string) => value.replace(/\D+/g, '')"></el-input>
                </template>
                <el-input v-else-if="property.PropertyName === 'Referral'" :disabled="referralQuery.length"
                  v-model="formModel[property.PropertyName]"></el-input>
                  <el-input v-else-if="property.PropertyName === 'BankAccountName'"
                  :disabled="formModel.Bank === '0' || formModel.Bank === ''" v-model="formModel[property.PropertyName]"></el-input>
                  <el-input v-else-if="property.PropertyName === 'BankAccountNumber'"
                    :disabled="formModel.Bank === '0' || formModel.Bank === ''" v-model="formModel[property.PropertyName]"
                    :formatter="(value: string) => value" :parser="(value: string) => value.replace(/\D+/g, '')">
                  </el-input>
                  <el-input v-else v-model="formModel[property.PropertyName]"></el-input>
              </el-form-item>
            </template>
              <el-form-item v-if="cashAgentQuery.length" :label="$t('agent_name')" prop="AgentName">
                <el-input :disabled="cashAgentQuery.length" v-model="formModel.AgentName" />
              </el-form-item>
              <el-form-item v-if="!clientCaptcha.IsHidden" prop="Captcha" :label="$t('enter_validation_code')">
                <div class="captcha">
                  <captcha
                    :value="formModel.Captcha"
                    @isValid="getCaptchaErrorMsg"
                  />
                  <el-input
                    v-model="formModel.Captcha"
                    type="text"
                    class="captcha-input"
                  />
                </div>
              </el-form-item>
            </div>
            <div class="action-container">
              <el-divider class="bg-border" style="margin-top: 1.5rem; margin-bottom: 1.5rem;" />
              <el-button class="w-full rounded" type="primary" :loading="isLoading" round @click="onRegister(formRef)">
                {{ $t('submit') }}
              </el-button>
              <div class="text-center mt-4 fc-text4 text-[12px]">{{ $t('already_have_an_account') }} ?
                <nuxt-link
                  class="text-primary underline cursor-pointer"
                  to="/login"
                >
                  {{ $t("capital_login") }}
                </nuxt-link>
              </div>
            </div>
          </el-form>
        </div>
        <div v-if="!loginRegister.IsHidden" class="relative w-[800px] h-[654px] flex justify-center items-center ol-bg-light login-register-image">
          <div class="text-center">
            <div class="w-[752px] h-[504px]">
              <img :src="loginRegister.ImagePath" class="w-full h-full object-contain" />
            </div>
            <div class="text-primary text-2xl font-black mb-1">
              <span>{{ $t('welcome_to') }}</span>
              <span v-if="!companyName.IsHidden" class="font-black text-[32px] fc-text4 ml-1">{{ companyName.Text }}</span>
            </div>
            <div class="text-base fc-text4">{{ $t(loginRegister.Text) }}</div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import { VueRecaptcha } from 'vue-recaptcha';
import useRegister from '@/composables/useRegister';
import { store } from '~~/store';
import { IThemePropertiesFromApi } from '~~/models/companyThemePropertiesRespone';

export default defineComponent({
  components: {
    reCaptcha: VueRecaptcha,
  },
  setup() {
    const themeProperties = computed(
    () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const companyName = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register_company_name"
      )
    );
    const loginRegister = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register"
      )
    );
    const {
      availableProperties,
      bankOptions,
      currencies,
      formModel,
      formRef,
      formRules,
      onRegister,
      getCaptchaErrorMsg,
      clientCaptcha,
      reCaptcha,
      reCaptchaSiteKey,
      onVerify,
      onRecaptchaError,
      isVerified,
      cashAgentQuery,
      referralQuery,
      isLoading,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    } = useRegister();
    const selectedThemeName = store.state.selectedThemeName;
    return {
      loginRegister,
      companyName,
      availableProperties,
      bankOptions,
      currencies,
      formModel,
      formRef,
      formRules,
      onRegister,
      getCaptchaErrorMsg,
      clientCaptcha,
      onVerify,
      reCaptcha,
      reCaptchaSiteKey,
      onRecaptchaError,
      isVerified,
      referralQuery,
      cashAgentQuery,
      isLoading,
      selectedThemeName,
      rules,
      nextRequestOtpInSeconds,
      isGettingOtpCode,
      onGetVerificationCode,
    };
  },
});
</script>

<style scoped lang="scss">
.login-register-image {
  --bg-base-color: var(--background5);
  --bg-opacity: 5%;
}
.el-popper.is-customized {
  width: 200px;
  padding: 6px 12px;
  background: white;
  box-shadow: #747474 0px 0px 5px;
}
.el-popper.is-customized .el-popper__arrow::before {
  background: white;
}
.el-radio-group {
  display: inline-flex;
}
.el-radio-group + :deep(.el-form-item__error) {
  position: absolute;
}
.el-form-item.is-error.verify__recaptcha__success > :where(.el-form-item__content) > :deep(.el-form-item__error) {
  display: none;
}
.el-form-item {
  display: block;
  margin-bottom: 1rem;
}
.el-form-item:last-of-type {
  margin-bottom: 0;
}
:deep(.el-form-item__label) {
  color: var(--text5);
  font-size: 14px;
}
.text-primary {
  color: var(--primary);
}
.register-inner {
  display: block;
}
.el-button.is-round {
  border-radius: 4px;
}
.el-divider--horizontal {
  border: 0;
  margin: 16px 0;
}
.register-form, .peru-register-form .action-container {
  padding: 0 2.5rem;

  @media screen and (max-width: 424px) {
    padding: 0 1rem;
  }
}
.register-form::-webkit-scrollbar, body::-webkit-scrollbar {
  width: 5px;
  height: 5px;
}
.register-form::-webkit-scrollbar-thumb, body::-webkit-scrollbar-thumb {
  background: var(--primary);
}
:deep(.el-radio__label) {
  font-size: 14px;
  font-weight: normal;
}
:deep(.el-radio__input.is-checked + .el-radio__label) {
  font-weight: 800;
}
:deep(.el-select .el-input .el-select__caret) {
  transform: rotateZ(0deg);
}
:deep(.el-select .el-input .el-select__caret.is-reverse) {
  transform: rotateZ(180deg);
}
:deep(.currency .el-input__suffix) {
  right: 20px;
}
:deep(.currency .el-input__prefix) {
  right: 5px;
  left: unset;
}
:deep(.currency .el-input__prefix .el-icon svg) {
  width: 12px;
  height: 12px;
  fill: var(--primary);
}
:deep(.currency .el-input--prefix .el-input__inner) {
  padding-left: 12px;
}
.login-container {

  @media screen and (max-width: 424px) {
    border-radius: 0;
  }
  .title-wrapper {
      padding: 1.5rem;
    }
  .login-register-form{
    @media screen and (max-width: 424px) {
      padding: 1.5rem;
    }
    form  {
      @media screen and (max-width: 424px) {
        padding: 0;
      }
    }
  }
}
.register-module {
  @media screen and (max-width: 639px) {
    padding: 1rem;
  }
  @media screen and (max-width: 424px) {
    padding: 0;
  }
}
.captcha {
  width: 100%;
  display: flex;
  gap: 0.5rem;
}
.vue_client_recaptcha {
  height: 32px;
  min-width: 128px;
}
:deep(.vue_client_recaptcha_icon) {
  height: 32px;
  width: fit-content;
  order: 2;
}
:deep(.vue_client_recaptcha_icon img) {
  width: 32px !important;
  height: 32px !important;
}
:deep(.vue_client_recaptcha .captcha_canvas) {
  width: 96px;
  height: 32px;
  order: 1;
  padding: 0;
}
:deep(.captcha-input .el-input__inner) {
  height: 32px !important;
}

:deep(.el-form-item:not(.is-error) .el-input__inner:hover), :deep(.el-form-item:not(.is-error) .el-select:hover .el-input__inner) {
  outline: 0;
  box-shadow: 0 0 0 1px var(--border) inset !important;
}
:deep(.el-form-item:not(.is-error) .el-input__inner:focus), :deep(.el-form-item:not(.is-error) .el-select .el-input.is-focus .el-input__inner) {
  outline: 0;
  box-shadow: 0 0 0 1px var(--selected) inset !important;
}
.register-module .form-only .login-register-form {
  max-width: 600px;
  width: 100%;
  margin: 0 auto;
}
</style>
